/* Copyright (C) 2003 Albert Seward
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sf.jlink;

import java.net.*;
import java.text.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class JConfig {
        private String path;
        private FileSystem fs = new FileSystem();
        private int port = 8000;
        private int securityModel = 1;
        private String allowedIP = "0.0.0.0";
        private String serverName = JLink.NAME + " " + JLink.VERSION;
        private String videoExt=".avi;.mpeg;.mpg;.m2v;.m2p";
        private String audioExt=".mp3;.wma;.ogg";
        private String pictureExt=".jpg;.jpeg;.png";
        private String sendBuffer="32768";
        private String clean="xvid;divx;dvdrip";
        private Boolean  dispVidExt=Boolean.FALSE;
        private Boolean dispAudExt=Boolean.TRUE;
        private Boolean dispPicExt=Boolean.FALSE;
        private Boolean cleanB=Boolean.TRUE;
        JConfig(String path) {
            this.path = path;  
            
        }
           
        public void save() throws FileNotFoundException, IOException {
            Properties config = new Properties();
            FileOutputStream out = new FileOutputStream(path);
            config.setProperty("port", "" + port);
            config.setProperty("securitymodel", "" + securityModel);
            config.setProperty("allowedip", allowedIP);
            config.setProperty("videoExt", videoExt);
            config.setProperty("audioExt", audioExt);
            config.setProperty("pictureExt", pictureExt);
            config.setProperty("sendBuffer", sendBuffer);
            config.setProperty("dispVidExt", dispVidExt.toString());
            config.setProperty("dispAudExt", dispAudExt.toString());
            config.setProperty("dispPicExt", dispPicExt.toString());
            config.setProperty("clean", clean);
            config.setProperty("cleanB", cleanB.toString());
            
            int count = 0;
            for(Enumeration e = fs.mounts.elements() ; e.hasMoreElements();) {
                Mount m = (Mount)e.nextElement();
                config.setProperty("mount" + count, m.getMountPoint() + ";" + m.getMapPath() + 
                                    ";-" + (m.supportM3U?"m":"") + (m.supportPLS?"p":""));
                count++;
            }
            config.store(out, "Savefile for Hell Link KISS DP-xxxx");
            out.close();
        }
                
        public void load() throws FileNotFoundException, IOException {        
            FileInputStream in = new FileInputStream(path);
            Properties config = new Properties();        
            config.load(in);
            in.close();
            
            securityModel = Integer.parseInt( config.getProperty("securitymodel",String.valueOf(securityModel)) );
            port = Integer.parseInt(config.getProperty("port",String.valueOf(port)) );
            videoExt = config.getProperty("videoExt",videoExt);
            audioExt = config.getProperty("audioExt",audioExt);
            pictureExt = config.getProperty("pictureExt",pictureExt);
            sendBuffer=config.getProperty("sendBuffer",sendBuffer);
            dispVidExt=Boolean.valueOf(config.getProperty("dispVidExt",String.valueOf(dispVidExt)) );
            dispAudExt=Boolean.valueOf(config.getProperty("dispAudExt",String.valueOf(dispAudExt)) );
            dispPicExt=Boolean.valueOf(config.getProperty("dispPicExt",String.valueOf(dispPicExt)) );
            clean=config.getProperty("clean",clean);
            cleanB=Boolean.valueOf(config.getProperty("cleanB",String.valueOf(cleanB)));
            
            allowedIP = config.getProperty("allowedip",allowedIP);
            for(Enumeration e = config.propertyNames(); e.hasMoreElements();) {
                        String key = (String)e.nextElement();      
                        if(key.startsWith("mount")) {
                             String arg[] = ((String)config.get(key)).split(";");
                             try {
                                Mount m = new Mount(arg[0].trim(), arg[1].trim());
                                fs.mounts.add(m);
                                m.supportPLS = (arg[2].indexOf('p') != -1);
                                m.supportM3U = (arg[2].indexOf('m') != -1);
                             } catch(DirectoryNotFoundException exp) {
                                JLink.error("Unable to parse configfile. Path not found \n" + arg[1].trim(), null, false );
                             }
                         } 
            }
        }
        
        public FileSystem getFileSystem() {
            return fs;
        }
        
        public String getServerName() {
            return serverName.trim();
        }
        
        public void setServerName(String serverName) {
            this.serverName = serverName;
        }
        
        public void setBufferSize(String Size)
        {
         sendBuffer=Size;   
        }
        public String getBufferSize()
        {
            return sendBuffer;
        }
        
        public String getCleanStrings()
        {
            return clean;
        }
        public boolean getClean()
        {
            return cleanB.booleanValue();
        }
        public void setCleanStrings(String Values, boolean cleanbool)
        {
            cleanB=Boolean.valueOf(cleanbool);
            clean=Values;
            
        }
        
        public void setExtDisplay(int type,boolean val)
        {
            if (type==0)
            {
                dispVidExt=Boolean.valueOf(val);
            }
            else if (type==1)
            {
                dispAudExt=Boolean.valueOf(val);
            }
            else if (type==2)
            {
                dispPicExt=Boolean.valueOf(val);
            }
                
        }
        
        public void setExtFile(int type,String Name)
        {
            if (type==0)
            {
                videoExt=Name;
            }
            else if (type==1)
            {
                audioExt=Name;
            }
            else if (type==2)
            {
                pictureExt=Name;
            }
                
        }
        
public boolean getExtDisplay(int type)
        {
            if (type==0)
            {
                return dispVidExt.booleanValue();
            }
            else if (type==1)
            {
                return dispAudExt.booleanValue();
            }
            else if (type==2)
            {
                return dispPicExt.booleanValue();
            }
            return true;
        }
               
        public String getExtFile(int type)
        {
            if (type==0)
            {
                return videoExt;
            }
            else if (type==1)
            {
                return audioExt;
            }
            else if (type==2)
            {
                return pictureExt;
            }
            return "no ext";
        }
        public boolean setAllowIP(String ip) {
            if(ip.trim().equals("")) {
                allowedIP = "0.0.0.0";
                return false;
            }
            String iplist[] = ip.split(";");
            for(int i = 0; i < iplist.length; i++) {
                String bytes[] = iplist[i].split("\\.");
                if(bytes.length != 4) {
                    return true;
                } else {
                    for(int j = 0; j < 4; j++) {
                        int num;
                        try {
                            num = Integer.parseInt(bytes[j].trim());
                        } catch(Exception e) {
                            return true;
                        }
                        if(num < 0 || num > 255)
                            return true;
                    }       
                }
            }
            allowedIP = ip;
            return false;
        }
        
        public String getAllowIP() {
            return allowedIP;
        }
              
        public boolean isAllowedIP(InetAddress ip) {
            if(securityModel == 3) {
                String iplist[] = allowedIP.split(";");
                for(int i = 0; i < iplist.length; i++) {
                    try {
                        if(InetAddress.getByName(iplist[i].trim()).equals(ip))
                            return true;
                    } catch(Exception e) {}
                }
                return false;
           } else if(securityModel == 1) {
                return true;
           } else if(securityModel == 2) {
               String ipadr = ip.getHostAddress();
               return(ipadr.matches("10\\.\\d*\\.\\d*\\.\\d*|192\\.168\\.\\d*\\.\\d*|172\\.(1[1-6]|2\\d|30|31)\\.\\d*\\.\\d*"));
           }
           return false;   
        }
        
        public void setSecurityModel(int model) {
            securityModel = model;
        }
        
        public int getSecurityModel() {
             return(securityModel);
        }
       
        public int getPort() {
            return(port);
        }

}

