/* Copyright (C) 2003 Albert Seward
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sf.jlink;
import java.io.*;
import java.util.*;

abstract public class PlayList {
     
    static public Vector list(String path, boolean fullPath) {     
        Vector ret = new Vector();
        BufferedReader pls;
        String line;
        boolean isM3u = false;
        try {
            File file = new File(path);
            if(!file.isFile() || !file.canRead())
                return null;
            pls = new BufferedReader(new FileReader(file));
            line = pls.readLine();
            //isM3u = line.equalsIgnoreCase("#EXTM3U");
            isM3u = true;
            if(!line.equalsIgnoreCase("[playlist]") && !isM3u) {
                ret.add("This playlist is broken ");
                return(ret);
            }
     
            while((line = pls.readLine()) != null) {
                if(line.startsWith("#") || (!line.startsWith("File") && !isM3u))
                    continue;
                if(!isM3u)
                    line = line.substring(line.indexOf("=") + 1);
                if(!fullPath) 
                    line = line.substring(line.lastIndexOf("\\") + 1);
                else if(line.startsWith("\\")) {
                    String root = path;
                    for(File f = new File(path); f != null;) {
                        root = f.getAbsolutePath();
                        f = f.getParentFile();
                    }
                    line = root + line.substring(1);
                } else
                    line = file.getParentFile().getAbsolutePath() + File.separator + line;
                ret.add(line);
            }
        } catch(Exception e) {
            return null;
        } 
        return(ret);
        
    }
     
    static public File getFile(String path) {
        try {
            String subpath = path.substring(0, path.lastIndexOf("/"));
            if(subpath.endsWith(".pls") || subpath.endsWith(".m3u")) {
                String file = "\\" + path.substring(subpath.length()+1);
                for(Iterator i = list(subpath, true).iterator(); i.hasNext();) {
                    String name = (String)i.next();
                    if(name.endsWith(file)) {
                        File f = new File(name);
                        if(f.isFile() && f.canRead())
                            return(f);
                        else
                            break;
                    }
                }
            }
        } catch(Exception e) {}
        return null;
    } 
   
}
