/***************************************************************************
                                 menubase.h
                             ------------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MENUBASE_H
#define MENUBASE_H

#include <qobject.h>
#include <qpopupmenu.h>
#include <qvaluelist.h>
#include <qstring.h>
#include <qpixmap.h>

class Transceiver;
class SysTrayManager;

class MenuBase : public QObject
{
    Q_OBJECT

    public :

        MenuBase( int id, Transceiver* pTransceiver, SysTrayManager* pManager );
        ~MenuBase();

        int  getId() { return m_id; }

        virtual void addItem( int index,
                              QString& label,
                              bool checkable,
                              bool checked,
                              bool enabled ) = 0;

        virtual void setToolTip( QString& toolTip ) = 0;
        virtual void setIcon( QPixmap& pixmap ) = 0;
        virtual void showIcon( bool show ) = 0;

        void enableItem( int index, bool enable );
        void checkItem( int index, bool check );
        void setItemLabel( int index, QString& label );
        void removeItem( int index );
        void removeAll();

    protected :

        QPopupMenu*          m_pMenu;
        QValueList< int >    m_checkableItems;
        SysTrayManager*      m_pManager;
        Transceiver*         m_pTransceiver;
        int                  m_id;

    private slots :

        void itemSelected( int id );
};

#endif
