/***************************************************************************
                                st4jevent.h
                             ------------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ST4JEVENT_H
#define ST4JEVENT_H

#include <qevent.h>
#include <qstring.h>
#include <qstringlist.h>

class SysTray4JavaEvent : public QCustomEvent
{
    public :

        SysTray4JavaEvent( int toDo,
                           int menuId,
                           QString& iconFileName,
                           QString& toolTip );

        SysTray4JavaEvent( int toDo, int menuId );

        SysTray4JavaEvent( int toDo,
                           int menuId,
                           int itemIndex,
                           QString& itemLabel,
                           bool checkable,
                           bool checked,
                           bool enabled );

        SysTray4JavaEvent( int toDo, int menuId, int itemIndex, QString& itemLabel );
        SysTray4JavaEvent( int toDo, int menuId, QString& toolTipOrIcon );
        SysTray4JavaEvent( int toDo, int menuId, int itemIndex, bool checkOrEnable );
        SysTray4JavaEvent( int toDo, int menuId, int itemIndex );
        SysTray4JavaEvent( int toDo, int menuId, bool showIcon );

        ~SysTray4JavaEvent();

        int getToDo() { return m_toDo; }
        int getMenuId() { return m_menuId; }
        QString& getItemLabel() { return *m_pItemLabel; }
        QString& getIconFileName() { return *m_pIconFileName; }
        QString& getToolTip() { return *m_pToolTip; }
        int getItemIndex() { return m_itemIndex; }
        bool getItemEnable() { return m_enable; }
        bool getItemCheck() { return m_check; }
        bool getItemCheckable() { return m_checkable; }
        bool getShowIcon() { return m_showIcon; }

    public :

        static int SYSTRAY4J_EVENT;

    private :

        int             m_toDo;
        int             m_menuId;
        QString*        m_pItemLabel;
        QString*        m_pIconFileName;
        QString*        m_pToolTip;
        int             m_itemIndex;
        bool            m_showIcon;
        bool            m_enable;
        bool            m_check;
        bool            m_checkable;
};

#endif
