/***************************************************************************
                                 submenu.cpp
                             -------------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "submenu.h"
#include "systraymanager.h"

void SubMenu::addItem( int id, QString& label, bool checkable, bool checked, bool enabled )
{
    SubMenu* psMenu = 0;

    // check whether the label refers to a submenu
    if( label.startsWith( "#SUB<" ) && label.contains( "><" ) && label.endsWith( ">" ) )
    {
        // submenu reference string format:
        //   #SUB<id><label>

        // extract the id of the submenu
        int begin = label.find( "<" ) + 1;
        QString strId = label.mid( begin, label.find( ">" ) - begin );

        // extract the label of the submenu
        begin = label.find( "><" ) + 2;
        label = label.mid( begin, label.length() - begin - 1 );

        int menuId = strId.toInt();
        psMenu = ( SubMenu* ) m_pManager->findMenu( menuId );
    }

    int pos = m_pMenu->count() - id;
    if( psMenu ) m_pMenu->insertItem( label, psMenu->getPopupMenu(), id, pos );
    else if( label != "#SEP" ) m_pMenu->insertItem( label, id, pos );
    else m_pMenu->insertSeparator( pos );

    int newId = id + 1;
    for( int i = pos - 1; i > -1; i-- ) m_pMenu->setId( i, newId++ );

    if( checkable )
    {
        m_checkableItems.append( id );
        if( checked ) checkItem( id, checked );
    }

    if( !enabled ) m_pMenu->setItemEnabled( id, enabled );
}
